import Vue from 'vue'
import router from './router'
import store from './store'
import NProgress from 'nprogress' // progress bar
import 'nprogress/nprogress.css' // progress bar style
import notification from 'ant-design-vue/es/notification'
import {
  ACCESS_TOKEN
} from '@/store/mutation-types'
import {
  generateIndexRouter
} from "@/utils/util"

NProgress.configure({
  showSpinner: false
}) // NProgress Configuration

const whiteList = ['/user/login', '/user/register', '/user/register-result', '/user/alteration', '/user/ueditor2'] // no redirect whitelist

router.beforeEach((to, from, next) => {

  NProgress.start() // start progress bar
  if (Vue.ls.get(ACCESS_TOKEN)) {
    /* has token */
    if (to.path === '/user/login') {
      next({
        path: '/dashboard/workplace'
      })
      NProgress.done()
    } else {
      // next();
      // return;

      if (store.getters.permissionList.length === 0) {
        store.dispatch('GetPermissionList').then(res => {

            const menuData = res;

            if (menuData === null || menuData === "" || menuData === undefined) {
              return;
            }
            let constRoutes = [];
            let list = new Array();
            list.push(menuData[1])
            constRoutes = generateIndexRouter(menuData);
            store.commit('SET_PERMISSIONLIST', constRoutes[0].children);
            // 添加主界面路由
            store.dispatch('UpdateAppRouter', {
              constRoutes
            }).then(() => {

              // 根据roles权限生成可访问的路由表
              // 动态添加可访问路由表
              router.addRoutes(store.getters.addRouters)

              constRoutes[0].children.splice(constRoutes[0].children.length-1,1); //删除项目介绍的目录
              store.commit('SET_PERMISSIONLIST', constRoutes[0].children);  //并重新引入

              const redirect = decodeURIComponent(from.query.redirect || to.path)
              if (to.path === redirect) {
                // hack方法 确保addRoutes已完成 ,set the replace: true so the navigation will not leave a history record
                next({
                  ...to,
                  replace: true
                })
              } else {
                // 跳转到目的路由
                next({
                  path: redirect
                })
              }
            })
          })
          .catch(() => {
            notification.error({
               message: '系统提示',
              description: '请求用户信息失败，请重试！'
            })
            store.dispatch('Logout').then(() => {
              next({
                path: '/user/login',
                query: {
                  redirect: to.fullPath
                }
              })
            })
            /*next({
              path:'/dashboard/analysis'
            })*/
          })
      } else {
        next()
      }
    }
  } else {
    if (whiteList.indexOf(to.path) !== -1) {
      // 在免登录白名单，直接进入
      next()
    } else {
      next({
        path: '/user/login',
        query: {
          redirect: to.fullPath
        }
      })
      NProgress.done() // if current page is login will not trigger afterEach hook, so manually handle it
    }
  }
})

router.afterEach(() => {
  NProgress.done() // finish progress bar
})
